/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-angular-core";
import { HorizontalAlignment_$type } from "igniteui-angular-core";
import { VerticalAlignment_$type } from "igniteui-angular-core";
import { Visibility_$type } from "igniteui-angular-core";
import { AxisLabelsLocation_$type } from "./AxisLabelsLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
/**
 * @hidden
 */
export let XYChart = /*@__PURE__*/ (() => {
    class XYChart extends DomainChart {
        constructor() {
            super(...arguments);
            this.kc = null;
            this.kd = null;
            this.kp = 0;
            this.kr = 5;
            this.kq = 0;
            this.ko = 5;
            this.k6 = 5;
            this.k8 = 0;
            this.k7 = 5;
            this.k5 = 0;
            this.pw = null;
            this.p3 = null;
            this.pu = null;
            this.pv = null;
            this.k0 = 0;
            this.lh = 0;
            this.kz = NaN;
            this.lg = NaN;
            this.k2 = NaN;
            this.lj = NaN;
            this.k1 = NaN;
            this.li = NaN;
            this.ky = NaN;
            this.lf = NaN;
            this.p2 = null;
            this.p9 = null;
            this.mr = null;
            this.mv = null;
            this.mt = null;
            this.mx = null;
            this.mm = null;
            this.mn = null;
            this.px = null;
            this.p4 = null;
            this.ks = 1;
            this.k9 = 1;
            this.kt = 1;
            this.la = 0;
            this.pz = null;
            this.p6 = null;
            this.p0 = null;
            this.p7 = null;
            this.ku = 1;
            this.lb = 1;
            this.kv = 5;
            this.lc = 0;
            this.p1 = null;
            this.p8 = null;
            this.kw = 2;
            this.ld = 2;
            this.ms = null;
            this.mw = null;
            this.py = null;
            this.p5 = null;
            this.kn = 0;
            this.k4 = 0;
            this.km = NaN;
            this.k3 = NaN;
            this.kx = 0;
            this.le = -90;
            this.ki = false;
            this.kj = false;
            this.pp = 1;
            this.qs = 1;
            this.po = 1;
            this.pq = 2;
            this.qq = 0;
            this.qr = 1;
            this.qw = 0;
            this.qx = 0;
            this.kg = 2;
            this.mq = null;
            this.j6 = null;
            this.mu = null;
            this.j7 = null;
        }
        provideContainer(a) {
            if (a != null) {
                let b = this.ka();
                let c = this.kb();
                if (b != null) {
                    b.provideRenderer(a);
                }
                if (c != null) {
                    c.provideRenderer(a);
                }
            }
            super.provideContainer(a);
        }
        ic() {
            super.ic();
            let a = this.ka();
            let b = this.kb();
            if (a != null && a.ay != null) {
                this.qc = a.ay.textColor;
            }
            if (b != null && b.ay != null) {
                this.qj = b.ay.textColor;
            }
        }
        i0(a, b, c) {
            super.i0(a, b, c);
            switch (a) {
                case "XAxisLabelLeftMargin":
                    this.pi((d) => d.leftMargin = this.lr);
                    break;
                case "XAxisLabelTopMargin":
                    this.pi((d) => d.topMargin = this.lt);
                    break;
                case "XAxisLabelRightMargin":
                    this.pi((d) => d.rightMargin = this.ls);
                    break;
                case "XAxisLabelBottomMargin":
                    this.pi((d) => d.bottomMargin = this.lq);
                    break;
                case "YAxisLabelLeftMargin":
                    this.pm((d) => d.leftMargin = this.l8);
                    break;
                case "YAxisLabelTopMargin":
                    this.pm((d) => d.topMargin = this.ma);
                    break;
                case "YAxisLabelRightMargin":
                    this.pm((d) => d.rightMargin = this.l9);
                    break;
                case "YAxisLabelBottomMargin":
                    this.pm((d) => d.bottomMargin = this.l7);
                    break;
                case "ActualItemsSource":
                case "ShouldDisplayMockData":
                case "ShouldUseSkeletonStyleForMockData":
                    this.qa = this.jz(this.qc);
                    this.qb = this.jz(this.qj);
                    break;
                case "XAxisLabelTextColor":
                    this.qa = this.jz(this.qc);
                    break;
                case "YAxisLabelTextColor":
                    this.qb = this.jz(this.qj);
                    break;
                case "ActualXAxisLabelTextColor":
                    this.pi((d) => d.textColor = this.qa);
                    break;
                case "ActualYAxisLabelTextColor":
                    this.pm((d) => d.textColor = this.qb);
                    break;
                case "XAxisTitleMargin":
                    this.pj((d) => d.margin = this.l2);
                    break;
                case "YAxisTitleMargin":
                    this.pn((d) => d.margin = this.mj);
                    break;
                case "XAxisTitleLeftMargin":
                    this.pj((d) => d.leftMargin = this.l1);
                    break;
                case "YAxisTitleLeftMargin":
                    this.pn((d) => d.leftMargin = this.mi);
                    break;
                case "XAxisTitleTopMargin":
                    this.pj((d) => d.topMargin = this.l4);
                    break;
                case "YAxisTitleTopMargin":
                    this.pn((d) => d.topMargin = this.ml);
                    break;
                case "XAxisTitleRightMargin":
                    this.pj((d) => d.rightMargin = this.l3);
                    break;
                case "YAxisTitleRightMargin":
                    this.pn((d) => d.rightMargin = this.mk);
                    break;
                case "XAxisTitleBottomMargin":
                    this.pj((d) => d.bottomMargin = this.l0);
                    break;
                case "YAxisTitleBottomMargin":
                    this.pn((d) => d.bottomMargin = this.mh);
                    break;
                case "XAxisTitleTextColor":
                    this.pj((d) => d.textColor = this.qi);
                    break;
                case "YAxisTitleTextColor":
                    this.pn((d) => d.textColor = this.qp);
                    break;
                case "XAxisFormatLabel":
                    this.pg((d) => d.at = this.ke);
                    break;
                case "YAxisFormatLabel":
                    this.pk((d) => d.at = this.kf);
                    break;
            }
        }
        get ke() {
            return this.kc;
        }
        set ke(a) {
            let b = this.ke;
            if (a != b) {
                this.kc = a;
                this.iz("XAxisFormatLabel", b, this.ke);
            }
        }
        get kf() {
            return this.kd;
        }
        set kf(a) {
            let b = this.kf;
            if (a != b) {
                this.kd = a;
                this.iz("YAxisFormatLabel", b, this.kf);
            }
        }
        get lr() {
            return this.kp;
        }
        set lr(a) {
            let b = this.lr;
            if (a != b) {
                this.kp = a;
                this.iz("XAxisLabelLeftMargin", b, this.lr);
            }
        }
        get lt() {
            return this.kr;
        }
        set lt(a) {
            let b = this.lt;
            if (a != b) {
                this.kr = a;
                this.iz("XAxisLabelTopMargin", b, this.lt);
            }
        }
        get ls() {
            return this.kq;
        }
        set ls(a) {
            let b = this.ls;
            if (a != b) {
                this.kq = a;
                this.iz("XAxisLabelRightMargin", b, this.ls);
            }
        }
        get lq() {
            return this.ko;
        }
        set lq(a) {
            let b = this.lq;
            if (a != b) {
                this.ko = a;
                this.iz("XAxisLabelBottomMargin", b, this.lq);
            }
        }
        get l8() {
            return this.k6;
        }
        set l8(a) {
            let b = this.l8;
            if (a != b) {
                this.k6 = a;
                this.iz("YAxisLabelLeftMargin", b, this.l8);
            }
        }
        get ma() {
            return this.k8;
        }
        set ma(a) {
            let b = this.ma;
            if (a != b) {
                this.k8 = a;
                this.iz("YAxisLabelTopMargin", b, this.ma);
            }
        }
        get l9() {
            return this.k7;
        }
        set l9(a) {
            let b = this.l9;
            if (a != b) {
                this.k7 = a;
                this.iz("YAxisLabelRightMargin", b, this.l9);
            }
        }
        get l7() {
            return this.k5;
        }
        set l7(a) {
            let b = this.l7;
            if (a != b) {
                this.k5 = a;
                this.iz("YAxisLabelBottomMargin", b, this.l7);
            }
        }
        get qc() {
            return this.pw;
        }
        set qc(a) {
            let b = this.qc;
            if (a != b) {
                this.pw = a;
                this.iz("XAxisLabelTextColor", b, this.qc);
            }
        }
        get qj() {
            return this.p3;
        }
        set qj(a) {
            let b = this.qj;
            if (a != b) {
                this.p3 = a;
                this.iz("YAxisLabelTextColor", b, this.qj);
            }
        }
        get qa() {
            return this.pu;
        }
        set qa(a) {
            let b = this.pu;
            if (a != b) {
                this.pu = a;
                this.iz("ActualXAxisLabelTextColor", b, this.qa);
            }
        }
        get qb() {
            return this.pv;
        }
        set qb(a) {
            let b = this.pv;
            if (a != b) {
                this.pv = a;
                this.iz("ActualYAxisLabelTextColor", b, this.qb);
            }
        }
        get l2() {
            return this.k0;
        }
        set l2(a) {
            let b = this.l2;
            if (a != b) {
                this.k0 = a;
                this.iz("XAxisTitleMargin", b, this.l2);
            }
        }
        get mj() {
            return this.lh;
        }
        set mj(a) {
            let b = this.mj;
            if (a != b) {
                this.lh = a;
                this.iz("YAxisTitleMargin", b, this.mj);
            }
        }
        get l1() {
            return this.kz;
        }
        set l1(a) {
            let b = this.l1;
            if (a != b) {
                this.kz = a;
                this.iz("XAxisTitleLeftMargin", b, this.l1);
            }
        }
        get mi() {
            return this.lg;
        }
        set mi(a) {
            let b = this.mi;
            if (a != b) {
                this.lg = a;
                this.iz("YAxisTitleLeftMargin", b, this.mi);
            }
        }
        get l4() {
            return this.k2;
        }
        set l4(a) {
            let b = this.l4;
            if (a != b) {
                this.k2 = a;
                this.iz("XAxisTitleTopMargin", b, this.l4);
            }
        }
        get ml() {
            return this.lj;
        }
        set ml(a) {
            let b = this.ml;
            if (a != b) {
                this.lj = a;
                this.iz("YAxisTitleTopMargin", b, this.ml);
            }
        }
        get l3() {
            return this.k1;
        }
        set l3(a) {
            let b = this.l3;
            if (a != b) {
                this.k1 = a;
                this.iz("XAxisTitleRightMargin", b, this.l3);
            }
        }
        get mk() {
            return this.li;
        }
        set mk(a) {
            let b = this.mk;
            if (a != b) {
                this.li = a;
                this.iz("YAxisTitleRightMargin", b, this.mk);
            }
        }
        get l0() {
            return this.ky;
        }
        set l0(a) {
            let b = this.l0;
            if (a != b) {
                this.ky = a;
                this.iz("XAxisTitleBottomMargin", b, this.l0);
            }
        }
        get mh() {
            return this.lf;
        }
        set mh(a) {
            let b = this.mh;
            if (a != b) {
                this.lf = a;
                this.iz("YAxisTitleBottomMargin", b, this.mh);
            }
        }
        get qi() {
            return this.p2;
        }
        set qi(a) {
            let b = this.qi;
            if (a != b) {
                this.p2 = a;
                this.iz("XAxisTitleTextColor", b, this.qi);
            }
        }
        get qp() {
            return this.p9;
        }
        set qp(a) {
            let b = this.qp;
            if (a != b) {
                this.p9 = a;
                this.iz("YAxisTitleTextColor", b, this.qp);
            }
        }
        i1(a, b, c) {
            super.i1(a, b, c);
            switch (a) {
                case "XAxisLabelTextStyle":
                    this.pi((d) => d.textStyle = this.ne);
                    break;
                case "YAxisLabelTextStyle":
                    this.pm((d) => d.textStyle = this.oj);
                    break;
                case "XAxisTitleTextStyle":
                    this.pj((d) => d.textStyle = this.n2);
                    break;
                case "YAxisTitleTextStyle":
                    this.pn((d) => d.textStyle = this.o7);
                    break;
            }
        }
        get ne() {
            return this.mr;
        }
        set ne(a) {
            let b = this.ne;
            if (a != b) {
                this.mr = a;
                this.iz("XAxisLabelTextStyle", b, this.ne);
            }
        }
        get oj() {
            return this.mv;
        }
        set oj(a) {
            let b = this.oj;
            if (a != b) {
                this.mv = a;
                this.iz("YAxisLabelTextStyle", b, this.oj);
            }
        }
        get n2() {
            return this.mt;
        }
        set n2(a) {
            let b = this.n2;
            if (a != b) {
                this.mt = a;
                this.iz("XAxisTitleTextStyle", b, this.n2);
            }
        }
        get o7() {
            return this.mx;
        }
        set o7(a) {
            let b = this.o7;
            if (a != b) {
                this.mx = a;
                this.iz("YAxisTitleTextStyle", b, this.o7);
            }
        }
        pd(a) {
            this.pa(a, (b) => b.leftMargin = this.lr);
            this.pa(a, (b) => b.topMargin = this.lt);
            this.pa(a, (b) => b.rightMargin = this.ls);
            this.pa(a, (b) => b.bottomMargin = this.lq);
            this.pa(a, (b) => b.textColor = this.qa);
            this.pb(a, (b) => b.textColor = this.qi);
            this.pb(a, (b) => b.leftMargin = this.l1);
            this.pb(a, (b) => b.topMargin = this.l4);
            this.pb(a, (b) => b.rightMargin = this.l3);
            this.pb(a, (b) => b.bottomMargin = this.l0);
            this.pa(a, (b) => b.textStyle = this.ne);
            this.pb(a, (b) => b.textStyle = this.n2);
        }
        pf(a) {
            this.pa(a, (b) => b.leftMargin = this.l8);
            this.pa(a, (b) => b.topMargin = this.ma);
            this.pa(a, (b) => b.rightMargin = this.l9);
            this.pa(a, (b) => b.bottomMargin = this.l7);
            this.pa(a, (b) => b.textColor = this.qb);
            this.pb(a, (b) => b.textColor = this.qp);
            this.pb(a, (b) => b.leftMargin = this.mi);
            this.pb(a, (b) => b.topMargin = this.ml);
            this.pb(a, (b) => b.rightMargin = this.mk);
            this.pb(a, (b) => b.bottomMargin = this.mh);
            this.pa(a, (b) => b.textStyle = this.oj);
            this.pb(a, (b) => b.textStyle = this.o7);
        }
        jg(a) {
            let b = this.ab(a);
            let c = this.a3(a, b);
            if (c == null) {
                return;
            }
            c.itemsSource = a.data;
            c.name = this.f0(a);
            c.gy = this.f1(a, b);
            this.dataChart.series.add(c);
        }
        pg(a) {
            this.ph(a, null);
        }
        ph(a, b) {
            a(this.ka());
        }
        pl(a, b) {
            a(this.kb());
        }
        pk(a) {
            this.pl(a, true);
        }
        pj(a) {
            this.pb(this.ka(), a);
        }
        pn(a) {
            this.pb(this.kb(), a);
        }
        pm(a) {
            this.pa(this.kb(), a);
        }
        pi(a) {
            this.pa(this.ka(), a);
        }
        lk(a) {
            let b = this.ka();
            return b.dz(a, new ScalerParams(1, this.j5, this.j4, b.ca));
        }
        lm(a) {
            let b = this.ka();
            return b.d2(a, new ScalerParams(1, this.j5, this.j4, b.ca));
        }
        ll(a) {
            let b = this.kb();
            return b.dz(a, new ScalerParams(1, this.j5, this.j4, b.ca));
        }
        ln(a) {
            let b = this.kb();
            return b.d2(a, new ScalerParams(1, this.j5, this.j4, b.ca));
        }
        je(a) {
            super.je(a);
            if (a == null) {
                return;
            }
            if (a.axes != null) {
                let b = this.ka();
                let c = this.kb();
                if (a.axes.contains(b)) {
                    a.axes.remove(b);
                }
                if (a.axes.contains(c)) {
                    a.axes.remove(c);
                }
            }
        }
        static m0(a, b) {
            for (let c of fromEnum(b)) {
                let d = c.findMatchingHint(16);
                if (d != null) {
                    let e = d.path;
                    return e;
                }
            }
            return null;
        }
        h7(a) {
            super.h7(a);
            if (a == this.dataChart) {
                this.dataChart.axes.add(this.ka());
                this.dataChart.axes.add(this.kb());
            }
        }
        pc(a) {
            if (a != null && this.er != null && a.ev == null) {
                a.provideRenderer(this.er);
            }
            a.it = this.qd;
            a.d6 = this.lu;
            a.iu = this.qe;
            a.d9 = this.lv;
            a.iw = this.qg;
            a.eq = this.lw;
            a.iv = this.qf;
            a.er = this.lx;
            a.ix = this.qh;
            a.es = this.ly;
            a.cq = true;
            let b = a == this.ka();
            if (b) {
                a.gd = this.nt;
            }
            a.fa = this.mo;
            a.fp = this.m6;
            a.ag = this.j8;
            this.pa(a, (c) => c.angle = this.lp);
            this.pa(a, (c) => {
                if (c.extent != this.lo) {
                    c.extent = this.lo;
                }
            });
            this.pa(a, (c) => c.horizontalAlignment = this.pr);
            this.pa(a, (c) => c.verticalAlignment = this.qt);
            this.pa(a, (c) => c.visibility = this.qy);
            this.pb(a, (c) => c.horizontalAlignment = this.ps);
            this.pb(a, (c) => c.angle = this.lz);
            this.pd(a);
        }
        pe(a) {
            if (a == null) {
                return;
            }
            if (this.er != null && a.ev == null) {
                a.provideRenderer(this.er);
            }
            this.pa(a, (b) => b.angle = this.l6);
            this.pa(a, (b) => {
                if (b.extent != this.l5) {
                    b.extent = this.l5;
                }
            });
            this.pa(a, (b) => b.horizontalAlignment = this.pt);
            this.pa(a, (b) => b.verticalAlignment = this.qu);
            this.pa(a, (b) => b.visibility = this.qz);
            this.pa(a, (b) => b.location = this.kh);
            this.pb(a, (b) => b.verticalAlignment = this.qv);
            this.pb(a, (b) => b.angle = this.mg);
            a.it = this.qk;
            a.d6 = this.mb;
            a.iu = this.ql;
            a.d9 = this.mc;
            a.iw = this.qn;
            a.eq = this.md;
            a.iv = this.qm;
            a.er = this.me;
            a.ix = this.qo;
            a.es = this.mf;
            let b = a == this.kb();
            if (b) {
                a.gd = this.oy;
            }
            a.fp = this.oa;
            a.ag = this.j9;
            this.pf(a);
        }
        h4() {
            super.h4();
            this.pc(this.ka());
            this.pe(this.kb());
        }
        pa(a, b) {
            if (a == null) {
                return;
            }
            if (a.ay == null) {
                a.ay = new AxisLabelSettings();
                a.ay.angle = a.dn();
                a.ay.bottomMargin = a.dp();
                a.ay.leftMargin = a.dq();
                a.ay.rightMargin = a.dr();
                a.ay.topMargin = a.ds();
                a.ay.horizontalAlignment = a.io();
                a.ay.location = a.az();
                a.ay.verticalAlignment = a.jh();
            }
            b(a.ay);
        }
        pb(a, b) {
            if (a == null) {
                return;
            }
            if (a.be == null) {
                a.be = new TitleSettings();
                a.be.bottomMargin = a.du();
                a.be.leftMargin = a.dv();
                a.be.rightMargin = a.dw();
                a.be.topMargin = a.dx();
                a.be.location = a.a0();
                a.be.angle = a.dt();
                a.be.horizontalAlignment = a.ip();
                a.be.verticalAlignment = a.ji();
            }
            b(a.be);
        }
        iz(a, b, c) {
            super.iz(a, b, c);
            switch (a) {
                case "XAxisLabelAngle":
                    this.pi((d) => d.angle = this.lp);
                    break;
                case "YAxisLabelAngle":
                    this.pm((d) => d.angle = this.l6);
                    break;
                case "XAxisLabelHorizontalAlignment":
                    this.pi((d) => d.horizontalAlignment = this.pr);
                    break;
                case "YAxisLabelHorizontalAlignment":
                    this.pm((d) => d.horizontalAlignment = this.pt);
                    break;
                case "XAxisLabelVerticalAlignment":
                    this.pi((d) => d.verticalAlignment = this.qt);
                    break;
                case "YAxisLabelVerticalAlignment":
                    this.pm((d) => d.verticalAlignment = this.qu);
                    break;
                case "XAxisLabelVisibility":
                    this.pi((d) => d.visibility = this.qy);
                    break;
                case "YAxisLabelVisibility":
                    this.pm((d) => d.visibility = this.qz);
                    break;
                case "XAxisLabel":
                    this.pg((d) => d.fa = this.mo);
                    break;
                case "YAxisLabel":
                    this.pk((d) => d.fa = this.mp);
                    break;
                case "XAxisLabelFormat":
                    this.pg((d) => d.fp = this.m6);
                    break;
                case "XAxisLabelFormatSpecifiers":
                    this.pg((d) => d.ag = this.j8);
                    break;
                case "YAxisLabelFormat":
                    this.pk((d) => d.fp = this.oa);
                    break;
                case "YAxisLabelFormatSpecifiers":
                    this.pk((d) => d.ag = this.j9);
                    break;
                case "XAxisTitleAngle":
                    this.pj((d) => d.angle = this.lz);
                    break;
                case "YAxisTitleAngle":
                    this.pn((d) => d.angle = this.mg);
                    break;
                case "XAxisTitleAlignment":
                    this.pj((d) => d.horizontalAlignment = this.ps);
                    break;
                case "YAxisTitleAlignment":
                    this.pn((d) => d.verticalAlignment = this.qv);
                    break;
                case "XAxisTitle":
                    this.pg((d) => d.gd = this.nt);
                    break;
                case "YAxisTitle":
                    this.pl((d) => d.gd = this.oy, false);
                    break;
                case "XAxisMajorStroke":
                    this.ph((d) => d.it = this.qd, a);
                    break;
                case "YAxisMajorStroke":
                    this.pk((d) => d.it = this.qk);
                    break;
                case "XAxisMajorStrokeThickness":
                    this.ph((d) => d.d6 = this.lu, a);
                    break;
                case "YAxisMajorStrokeThickness":
                    this.pk((d) => d.d6 = this.mb);
                    break;
                case "XAxisMinorStroke":
                    this.pg((d) => d.iu = this.qe);
                    break;
                case "YAxisMinorStroke":
                    this.pk((d) => d.iu = this.ql);
                    break;
                case "XAxisMinorStrokeThickness":
                    this.pg((d) => d.d9 = this.lv);
                    break;
                case "YAxisMinorStrokeThickness":
                    this.pk((d) => d.d9 = this.mc);
                    break;
                case "XAxisTickLength":
                    this.pg((d) => d.er = this.lx);
                    break;
                case "YAxisTickLength":
                    this.pk((d) => d.er = this.me);
                    break;
                case "XAxisTickStroke":
                    this.pg((d) => d.ix = this.qh);
                    break;
                case "YAxisTickStroke":
                    this.pk((d) => d.ix = this.qo);
                    break;
                case "XAxisTickStrokeThickness":
                    this.pg((d) => d.es = this.ly);
                    break;
                case "YAxisTickStrokeThickness":
                    this.pk((d) => d.es = this.mf);
                    break;
                case "XAxisStroke":
                    this.pg((d) => d.iw = this.qg);
                    break;
                case "YAxisStroke":
                    this.pk((d) => d.iw = this.qn);
                    break;
                case "XAxisStrokeThickness":
                    this.pg((d) => d.eq = this.lw);
                    break;
                case "YAxisStrokeThickness":
                    this.pk((d) => d.eq = this.md);
                    break;
                case "XAxisExtent":
                    this.pi((d) => d.extent = this.lo);
                    break;
                case "YAxisExtent":
                    this.pm((d) => d.extent = this.l5);
                    break;
                case "XAxisStrip":
                    this.pg((d) => d.iv = this.qf);
                    break;
                case "YAxisStrip":
                    this.pk((d) => d.iv = this.qm);
                    break;
                case "XAxisInverted":
                    this.pg((d) => d.ca = this.kk);
                    break;
                case "YAxisInverted":
                    this.pk((d) => d.ca = this.kl);
                    break;
                case "YAxisLabelLocation":
                    this.pm((d) => d.location = this.kh);
                    break;
            }
        }
        get mo() {
            return this.mm;
        }
        set mo(a) {
            let b = this.mo;
            if (a != b) {
                this.mm = a;
                this.iz("XAxisLabel", b, this.mo);
            }
        }
        get mp() {
            return this.mn;
        }
        set mp(a) {
            let b = this.mp;
            if (a != b) {
                this.mn = a;
                this.iz("YAxisLabel", b, this.mp);
            }
        }
        get qd() {
            return this.px;
        }
        set qd(a) {
            let b = this.qd;
            if (a != b) {
                this.px = a;
                this.iz("XAxisMajorStroke", b, this.qd);
            }
        }
        get qk() {
            return this.p4;
        }
        set qk(a) {
            let b = this.qk;
            if (a != b) {
                this.p4 = a;
                this.iz("YAxisMajorStroke", b, this.qk);
            }
        }
        get lu() {
            return this.ks;
        }
        set lu(a) {
            let b = this.lu;
            if (a != b) {
                this.ks = a;
                this.iz("XAxisMajorStrokeThickness", b, this.lu);
            }
        }
        get mb() {
            return this.k9;
        }
        set mb(a) {
            let b = this.mb;
            if (a != b) {
                this.k9 = a;
                this.iz("YAxisMajorStrokeThickness", b, this.mb);
            }
        }
        get lv() {
            return this.kt;
        }
        set lv(a) {
            let b = this.lv;
            if (a != b) {
                this.kt = a;
                this.iz("XAxisMinorStrokeThickness", b, this.lv);
            }
        }
        get mc() {
            return this.la;
        }
        set mc(a) {
            let b = this.mc;
            if (a != b) {
                this.la = a;
                this.iz("YAxisMinorStrokeThickness", b, this.mc);
            }
        }
        get qf() {
            return this.pz;
        }
        set qf(a) {
            let b = this.qf;
            if (a != b) {
                this.pz = a;
                this.iz("XAxisStrip", b, this.qf);
            }
        }
        get qm() {
            return this.p6;
        }
        set qm(a) {
            let b = this.qm;
            if (a != b) {
                this.p6 = a;
                this.iz("YAxisStrip", b, this.qm);
            }
        }
        get qg() {
            return this.p0;
        }
        set qg(a) {
            let b = this.qg;
            if (a != b) {
                this.p0 = a;
                this.iz("XAxisStroke", b, this.qg);
            }
        }
        get qn() {
            return this.p7;
        }
        set qn(a) {
            let b = this.qn;
            if (a != b) {
                this.p7 = a;
                this.iz("YAxisStroke", b, this.qn);
            }
        }
        get lw() {
            return this.ku;
        }
        set lw(a) {
            let b = this.lw;
            if (a != b) {
                this.ku = a;
                this.iz("XAxisStrokeThickness", b, this.lw);
            }
        }
        get md() {
            return this.lb;
        }
        set md(a) {
            let b = this.md;
            if (a != b) {
                this.lb = a;
                this.iz("YAxisStrokeThickness", b, this.md);
            }
        }
        get lx() {
            return this.kv;
        }
        set lx(a) {
            let b = this.lx;
            if (a != b) {
                this.kv = a;
                this.iz("XAxisTickLength", b, this.lx);
            }
        }
        get me() {
            return this.lc;
        }
        set me(a) {
            let b = this.me;
            if (a != b) {
                this.lc = a;
                this.iz("YAxisTickLength", b, this.me);
            }
        }
        get qh() {
            return this.p1;
        }
        set qh(a) {
            let b = this.qh;
            if (a != b) {
                this.p1 = a;
                this.iz("XAxisTickStroke", b, this.qh);
            }
        }
        get qo() {
            return this.p8;
        }
        set qo(a) {
            let b = this.qo;
            if (a != b) {
                this.p8 = a;
                this.iz("YAxisTickStroke", b, this.qo);
            }
        }
        get ly() {
            return this.kw;
        }
        set ly(a) {
            let b = this.ly;
            if (a != b) {
                this.kw = a;
                this.iz("XAxisTickStrokeThickness", b, this.ly);
            }
        }
        get mf() {
            return this.ld;
        }
        set mf(a) {
            let b = this.mf;
            if (a != b) {
                this.ld = a;
                this.iz("YAxisTickStrokeThickness", b, this.mf);
            }
        }
        get nt() {
            return this.ms;
        }
        set nt(a) {
            let b = this.nt;
            if (a != b) {
                this.ms = a;
                this.iz("XAxisTitle", b, this.nt);
            }
        }
        get oy() {
            return this.mw;
        }
        set oy(a) {
            let b = this.oy;
            if (a != b) {
                this.mw = a;
                this.iz("YAxisTitle", b, this.oy);
            }
        }
        get qe() {
            return this.py;
        }
        set qe(a) {
            let b = this.qe;
            if (a != b) {
                this.py = a;
                this.iz("XAxisMinorStroke", b, this.qe);
            }
        }
        get ql() {
            return this.p5;
        }
        set ql(a) {
            let b = this.ql;
            if (a != b) {
                this.p5 = a;
                this.iz("YAxisMinorStroke", b, this.ql);
            }
        }
        get lp() {
            return this.kn;
        }
        set lp(a) {
            let b = this.lp;
            if (a != b) {
                this.kn = a;
                this.iz("XAxisLabelAngle", b, this.lp);
            }
        }
        get l6() {
            return this.k4;
        }
        set l6(a) {
            let b = this.l6;
            if (a != b) {
                this.k4 = a;
                this.iz("YAxisLabelAngle", b, this.l6);
            }
        }
        get lo() {
            return this.km;
        }
        set lo(a) {
            let b = this.lo;
            if (a != b) {
                this.km = a;
                this.iz("XAxisExtent", b, this.lo);
            }
        }
        get l5() {
            return this.k3;
        }
        set l5(a) {
            let b = this.l5;
            if (a != b) {
                this.k3 = a;
                this.iz("YAxisExtent", b, this.l5);
            }
        }
        get lz() {
            return this.kx;
        }
        set lz(a) {
            let b = this.lz;
            if (a != b) {
                this.kx = a;
                this.iz("XAxisTitleAngle", b, this.lz);
            }
        }
        get mg() {
            return this.le;
        }
        set mg(a) {
            let b = this.mg;
            if (a != b) {
                this.le = a;
                this.iz("YAxisTitleAngle", b, this.mg);
            }
        }
        get kk() {
            return this.ki;
        }
        set kk(a) {
            let b = this.kk;
            if (a != b) {
                this.ki = a;
                this.iz("XAxisInverted", b, this.kk);
            }
        }
        get kl() {
            return this.kj;
        }
        set kl(a) {
            let b = this.kl;
            if (a != b) {
                this.kj = a;
                this.iz("YAxisInverted", b, this.kl);
            }
        }
        get ps() {
            return this.pp;
        }
        set ps(a) {
            let b = this.ps;
            if (a != b) {
                this.pp = a;
                this.iz("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.ps));
            }
        }
        get qv() {
            return this.qs;
        }
        set qv(a) {
            let b = this.qv;
            if (a != b) {
                this.qs = a;
                this.iz("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.qv));
            }
        }
        get pr() {
            return this.po;
        }
        set pr(a) {
            let b = this.pr;
            if (a != b) {
                this.po = a;
                this.iz("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.pr));
            }
        }
        get_pt() {
            return this.pq;
        }
        set_pt(a) {
            let b = this.pt;
            if (a != b) {
                this.pq = a;
                this.iz("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.pt));
            }
        }
        get pt() {
            return this.get_pt();
        }
        set pt(a) {
            this.set_pt(a);
        }
        get qt() {
            return this.qq;
        }
        set qt(a) {
            let b = this.qt;
            if (a != b) {
                this.qq = a;
                this.iz("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.qt));
            }
        }
        get qu() {
            return this.qr;
        }
        set qu(a) {
            let b = this.qu;
            if (a != b) {
                this.qr = a;
                this.iz("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.qu));
            }
        }
        get qy() {
            return this.qw;
        }
        set qy(a) {
            let b = this.qy;
            if (a != b) {
                this.qw = a;
                this.iz("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.qy));
            }
        }
        get qz() {
            return this.qx;
        }
        set qz(a) {
            let b = this.qz;
            if (a != b) {
                this.qx = a;
                this.iz("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.qz));
            }
        }
        get_kh() {
            return this.kg;
        }
        set_kh(a) {
            let b = this.kh;
            if (a != b) {
                this.kg = a;
                this.iz("YAxisLabelLocation", enumGetBox(AxisLabelsLocation_$type, b), enumGetBox(AxisLabelsLocation_$type, this.kh));
            }
        }
        get kh() {
            return this.get_kh();
        }
        set kh(a) {
            this.set_kh(a);
        }
        get m6() {
            return this.mq;
        }
        set m6(a) {
            let b = this.mq;
            if (a != b) {
                this.mq = a;
                this.iz("XAxisLabelFormat", b, this.mq);
            }
        }
        get j8() {
            return this.j6;
        }
        set j8(a) {
            let b = this.j6;
            if (a != b) {
                this.j6 = a;
                this.iz("XAxisLabelFormatSpecifiers", b, this.j6);
            }
        }
        get oa() {
            return this.mu;
        }
        set oa(a) {
            let b = this.mu;
            if (a != b) {
                this.mu = a;
                this.iz("YAxisLabelFormat", b, this.mu);
            }
        }
        get j9() {
            return this.j7;
        }
        set j9(a) {
            let b = this.j7;
            if (a != b) {
                this.j7 = a;
                this.iz("YAxisLabelFormatSpecifiers", b, this.j7);
            }
        }
    }
    XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
})();
//# sourceMappingURL=XYChart.js.map
