import { FunnelSliceClickedEventArgs as FunnelSliceClickedEventArgs_internal } from "./FunnelSliceClickedEventArgs";
/**
 * Information about the clicked slice.
*/
export class IgxFunnelSliceClickedEventArgs {
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return new FunnelSliceClickedEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * The index of the clicked slice.
    */
    get index() {
        return this.i.index;
    }
    set index(v) {
        this.i.index = +v;
    }
    /**
     * The data item for the clicked slice.
    */
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
}
//# sourceMappingURL=igx-funnel-slice-clicked-event-args.js.map